Index: /pjproject/trunk/pjsip/src/pjsip/sip_transport.c
===================================================================
--- /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 53)
+++ /pjproject/trunk/pjsip/src/pjsip/sip_transport.c	(revision 54)
@@ -733,120 +309,285 @@
     }
 
-    /* Send the message. */
-    buf = tdata->buf.start;
-    size = tdata->buf.cur - tdata->buf.start;
-
-    if (tr->type == PJSIP_TRANSPORT_UDP) {
-	PJ_LOG(4,(tr->obj_name, "sendto %s:%d, %d bytes, data:\n"
-		  "----------- begin msg ------------\n"
-		  "%s"
-		  "------------ end msg -------------",
-		  pj_inet_ntoa(addr->sin_addr), 
-		  pj_sockaddr_in_get_port(addr),
-		  size, buf));
-
-	status = pj_ioqueue_sendto( tr->key, &tdata->op_key,
-				    buf, &size, 0, addr, sizeof(*addr));
-    } 
-#if PJ_HAS_TCP
-    else {
-	PJ_LOG(4,(tr->obj_name, "sending %d bytes, data:\n"
-		  "----------- begin msg ------------\n"
-		  "%s"
-		  "------------ end msg -------------",
-		  size, buf));
-
-	status = pj_ioqueue_send(tr->key, &tdata->op_key, buf, &size, 0);
-    }
-#else
-    else {
-	pj_assert(!"Unsupported transport");
-	status = PJSIP_EUNSUPTRANSPORT;
-    }
-#endif
-
-    *p_sent = size;
+    /* Save callback data. */
+    tdata->token = token;
+    tdata->cb = cb;
+
+    /* Add reference counter. */
+    pjsip_tx_data_add_ref(tdata);
+
+    /* Mark as pending. */
+    tdata->is_pending = 1;
+
+    /* Send to transport. */
+    status = (*tr->send_msg)(tr, tdata->buf.start, 
+			     tdata->buf.cur - tdata->buf.start,
+			     &tdata->op_key,
+			     addr, tdata, &transport_send_callback);
+
+    if (status != PJ_EPENDING) {
+	tdata->is_pending = 0;
+	pjsip_tx_data_dec_ref(tdata);
+    }
+
     return status;
 }
 
-/*
- * Send a SIP message using the specified transport, to the address specified
- * in the outgoing data.
- */
-PJ_DEF(pj_status_t) pjsip_transport_send_msg( pjsip_transport_t *tr,
-					      pjsip_tx_data *tdata,
-					      const pj_sockaddr_in *addr,
-					      pj_ssize_t *sent)
-{
-    PJ_LOG(5, (tr->obj_name, "pjsip_transport_send_msg(tdata=%s)", tdata->obj_name));
-
-    return transport_send_msg(tr, tdata, addr, sent );
-}
-
-///////////////////////////////////////////////////////////////////////////////
+static void transport_idle_callback(pj_timer_heap_t *timer_heap,
+				    struct pj_timer_entry *entry)
+{
+    pjsip_transport *tp = entry->user_data;
+    pj_assert(tp != NULL);
+
+    PJ_UNUSED_ARG(timer_heap);
+
+    entry->id = PJ_FALSE;
+    pjsip_transport_unregister(tp->tpmgr, tp);
+}
+
+/*
+ * Add ref.
+ */
+PJ_DEF(pj_status_t) pjsip_transport_add_ref( pjsip_transport *tp )
+{
+    PJ_ASSERT_RETURN(tp != NULL, PJ_EINVAL);
+
+    if (pj_atomic_inc_and_get(tp->ref_cnt) == 1) {
+	pj_lock_acquire(tp->tpmgr->lock);
+	/* Verify again. */
+	if (pj_atomic_get(tp->ref_cnt) == 1) {
+	    if (tp->idle_timer.id != PJ_FALSE) {
+		pj_timer_heap_cancel(tp->tpmgr->timer_heap, &tp->idle_timer);
+		tp->idle_timer.id = PJ_FALSE;
+	    }
+	}
+	pj_lock_release(tp->tpmgr->lock);
+    }
+
+    return PJ_SUCCESS;
+}
+
+/*
+ * Dec ref.
+ */
+PJ_DEF(pj_status_t) pjsip_transport_dec_ref( pjsip_transport *tp )
+{
+    PJ_ASSERT_RETURN(tp != NULL, PJ_EINVAL);
+
+    pj_assert(pj_atomic_get(tp->ref_cnt) > 0);
+
+    if (pj_atomic_dec_and_get(tp->ref_cnt) == 0) {
+	pj_lock_acquire(tp->tpmgr->lock);
+	/* Verify again. */
+	if (pj_atomic_get(tp->ref_cnt) == 0) {
+	    pj_time_val delay = { PJSIP_TRANSPORT_IDLE_TIME, 0 };
+
+	    pj_assert(tp->idle_timer.id == 0);
+	    tp->idle_timer.id = PJ_TRUE;
+	    pj_timer_heap_schedule(tp->tpmgr->timer_heap, &tp->idle_timer, &delay);
+	}
+	pj_lock_release(tp->tpmgr->lock);
+    }
+
+    return PJ_SUCCESS;
+}
+
+
+/**
+ * Register a transport.
+ */
+PJ_DEF(pj_status_t) pjsip_transport_register( pjsip_tpmgr *mgr,
+					      pjsip_transport *tp )
+{
+    transport_key key;
+
+    /* Init. */
+    tp->tpmgr = mgr;
+    pj_memset(&tp->idle_timer, 0, sizeof(tp->idle_timer));
+    tp->idle_timer.user_data = tp;
+    tp->idle_timer.cb = &transport_idle_callback;
+
+    /* 
+     * Register to hash table.
+     */
+    key.type = (pj_uint8_t)tp->type;
+    key.zero = 0;
+    key.addr = pj_ntohl(tp->rem_addr.sin_addr.s_addr);
+    key.port = pj_ntohs(tp->rem_addr.sin_port);
+
+    pj_lock_acquire(mgr->lock);
+    pj_hash_set(tp->pool, mgr->table, &key, sizeof(key), tp);
+    pj_lock_release(mgr->lock);
+
+    return PJ_SUCCESS;
+}
+
+
+/**
+ * Unregister transport.
+ */
+PJ_DEF(pj_status_t) pjsip_transport_unregister( pjsip_tpmgr *mgr,
+						pjsip_transport *tp)
+{
+    transport_key key;
+
+    PJ_ASSERT_RETURN(pj_atomic_get(tp->ref_cnt) == 0, PJSIP_EBUSY);
+
+    pj_lock_acquire(tp->lock);
+    pj_lock_acquire(mgr->lock);
+
+    /*
+     * Unregister timer, if any.
+     */
+    pj_assert(tp->idle_timer.id == PJ_FALSE);
+    if (tp->idle_timer.id != PJ_FALSE) {
+	pj_timer_heap_cancel(mgr->timer_heap, &tp->idle_timer);
+	tp->idle_timer.id = PJ_FALSE;
+    }
+
+    /*
+     * Unregister from hash table.
+     */
+    key.type = (pj_uint8_t)tp->type;
+    key.zero = 0;
+    key.addr = pj_ntohl(tp->rem_addr.sin_addr.s_addr);
+    key.port = pj_ntohs(tp->rem_addr.sin_port);
+
+    pj_hash_set(tp->pool, mgr->table, &key, sizeof(key), NULL);
+
+    pj_lock_release(mgr->lock);
+
+    /* Destroy. */
+    return tp->destroy(tp);
+}
+
+
+
+/*****************************************************************************
+ *
+ * TRANSPORT FACTORY
+ *
+ *****************************************************************************/
+
+
+PJ_DEF(pj_status_t) pjsip_tpmgr_register_tpfactory( pjsip_tpmgr *mgr,
+						    pjsip_tpfactory *tpf)
+{
+    pjsip_tpfactory *p;
+    pj_status_t status;
+
+    pj_lock_acquire(mgr->lock);
+
+    /* Check that no factory with the same type has been registered. */
+    status = PJ_SUCCESS;
+    for (p=mgr->factory_list.next; p!=&mgr->factory_list; p=p->next) {
+	if (p->type == tpf->type) {
+	    status = PJSIP_ETYPEEXISTS;
+	    break;
+	}
+	if (p == tpf) {
+	    status = PJ_EEXISTS;
+	    break;
+	}
+    }
+
+    if (status != PJ_SUCCESS) {
+	pj_lock_release(mgr->lock);
+	return status;
+    }
+
+    pj_list_insert_before(&mgr->factory_list, tpf);
+
+    pj_lock_release(mgr->lock);
+
+    return PJ_SUCCESS;
+}
+
+
+/**
+ * Unregister factory.
+ */
+PJ_DEF(pj_status_t) pjsip_tpmgr_unregister_tpfactory( pjsip_tpmgr *mgr,
+						      pjsip_tpfactory *tpf)
+{
+    pj_lock_acquire(mgr->lock);
+
+    pj_assert(pj_list_find_node(&mgr->factory_list, tpf) == tpf);
+    pj_list_erase(tpf);
+
+    pj_lock_release(mgr->lock);
+
+    return PJ_SUCCESS;
+}
+
+
+/*****************************************************************************
+ *
+ * TRANSPORT MANAGER
+ *
+ *****************************************************************************/
 
 /*
  * Create a new transport manager.
  */
-PJ_DEF(pj_status_t) pjsip_transport_mgr_create( pj_pool_t *pool,
-						pjsip_endpoint * endpt,
-						void (*cb)(pjsip_endpoint*,
-							   pjsip_rx_data *),
-						pjsip_transport_mgr **p_mgr)
-{
-    pjsip_transport_mgr *mgr;
+PJ_DEF(pj_status_t) pjsip_tpmgr_create( pj_pool_t *pool,
+					pjsip_endpoint *endpt,
+					pj_ioqueue_t *ioqueue,
+					pj_timer_heap_t *timer_heap,
+					void (*cb)(pjsip_endpoint*,
+						   pj_status_t,
+						   pjsip_rx_data *),
+					pjsip_tpmgr **p_mgr)
+{
+    pjsip_tpmgr *mgr;
     pj_status_t status;
 
-    PJ_LOG(5, (LOG_TRANSPORT_MGR, "pjsip_transport_mgr_create()"));
-
-    mgr = pj_pool_alloc(pool, sizeof(*mgr));
+    PJ_ASSERT_RETURN(pool && endpt && cb && p_mgr, PJ_EINVAL);
+
+    PJ_LOG(5, (THIS_FILE, "pjsip_tpmgr_create()"));
+
+    mgr = pj_pool_zalloc(pool, sizeof(*mgr));
     mgr->endpt = endpt;
-    mgr->message_callback = cb;
-    mgr->send_buf_size = DEFAULT_SO_SNDBUF;
-    mgr->recv_buf_size = DEFAULT_SO_RCVBUF;
-
-    mgr->transport_table = pj_hash_create(pool, MGR_HASH_TABLE_SIZE);
-    if (!mgr->transport_table) {
+    mgr->msg_cb = cb;
+    mgr->ioqueue = ioqueue;
+    mgr->timer_heap = timer_heap;
+    pj_list_init(&mgr->factory_list);
+
+    mgr->table = pj_hash_create(pool, PJSIP_TPMGR_HTABLE_SIZE);
+    if (!mgr->table)
 	return PJ_ENOMEM;
-    }
-    status = pj_ioqueue_create(pool, PJSIP_MAX_TRANSPORTS, &mgr->ioqueue);
-    if (status != PJ_SUCCESS) {
+
+    status = pj_lock_create_recursive_mutex(pool, "tmgr%p", &mgr->lock);
+    if (status != PJ_SUCCESS)
 	return status;
-    }
-    status = pj_mutex_create_recursive(pool, "tmgr%p", &mgr->mutex);
-    if (status != PJ_SUCCESS) {
-	pj_ioqueue_destroy(mgr->ioqueue);
-	return status;
-    }
-    pj_gettimeofday(&mgr->next_idle_check);
-    mgr->next_idle_check.sec += MGR_IDLE_CHECK_INTERVAL;
 
     *p_mgr = mgr;
-    return status;
-}
-
-/*
+    return PJ_SUCCESS;
+}
+
+/*
+ * pjsip_tpmgr_destroy()
+ *
  * Destroy transport manager.
  */
-PJ_DEF(pj_status_t) pjsip_transport_mgr_destroy( pjsip_transport_mgr *mgr )
+PJ_DEF(pj_status_t) pjsip_tpmgr_destroy( pjsip_tpmgr *mgr )
 {
     pj_hash_iterator_t itr_val;
     pj_hash_iterator_t *itr;
     
-    PJ_LOG(5, (LOG_TRANSPORT_MGR, "pjsip_transport_mgr_destroy()"));
-
-    pj_mutex_lock(mgr->mutex);
-
-    itr = pjsip_transport_first(mgr, &itr_val);
+    PJ_LOG(5, (THIS_FILE, "pjsip_tpmgr_destroy()"));
+
+    pj_lock_acquire(mgr->lock);
+
+    itr = pj_hash_first(mgr->table, &itr_val);
     while (itr != NULL) {
 	pj_hash_iterator_t *next;
-	pjsip_transport_t *transport;
+	pjsip_transport *transport;
 	
-	transport = pjsip_transport_this(mgr, itr);
-
-	next = pjsip_transport_next(mgr, itr);
+	transport = pj_hash_this(mgr->table, itr);
+
+	next = pj_hash_next(mgr->table, itr);
 
 	pj_atomic_set(transport->ref_cnt, 0);
-	destroy_transport( mgr, transport);
+	pjsip_transport_unregister(mgr, transport);
 
 	itr = next;
@@ -854,615 +595,112 @@
     pj_ioqueue_destroy(mgr->ioqueue);
 
-    pj_mutex_unlock(mgr->mutex);
+    pj_lock_release(mgr->lock);
 
     return PJ_SUCCESS;
 }
 
-/*
- * Create listener
- */
-static pj_status_t create_listener( pjsip_transport_mgr *mgr,
-				    pjsip_transport_type_e type,
-				    pj_sock_t sock_hnd,
-				    pj_sockaddr_in *local_addr,
-				    const pj_sockaddr_in *addr_name)
-{
-    pjsip_transport_t *tr;
-    struct transport_key *hash_key;
-    const pj_str_t loopback_addr = { "127.0.0.1", 9 };
-    pj_status_t status;
-
-    if (mgr->send_buf_size != 0) {
-        int opt_val = mgr->send_buf_size;
-        status = pj_sock_setsockopt( sock_hnd, PJ_SOL_SOCKET, 
-                                     PJ_SO_SNDBUF, 
-                                     &opt_val, sizeof(opt_val));
-
-        if (status != PJ_SUCCESS) {
-	    return status;
-        }
-    }
-
-    if (mgr->recv_buf_size != 0) {
-        int opt_val = mgr->recv_buf_size;
-        status = pj_sock_setsockopt( sock_hnd, PJ_SOL_SOCKET, 
-                                     PJ_SO_RCVBUF, 
-                                     &opt_val, sizeof(opt_val));
-        if (status != PJ_SUCCESS) {
-	    return status;
-        }
-    }
-
-    status = create_transport(mgr, type, sock_hnd, local_addr, addr_name, &tr);
-    if (status != PJ_SUCCESS) {
-	pj_sock_close(sock_hnd);
-	return status;
-    }
-#if PJ_HAS_TCP
-    if (type == PJSIP_TRANSPORT_TCP) {
-
-	status = pj_sock_listen(tr->sock, BACKLOG);
-	if (status != 0) {
-	    destroy_transport(mgr, tr);
-	    return status;
-	}
-	
-	/* Discard immediate connections. */
-	do {
-	    tr->accept_data.addrlen = sizeof(tr->accept_data.local);
-	    status = pj_ioqueue_accept(tr->key, &tr->accept_op,
-				       &tr->accept_data.sock, 
-				       &tr->accept_data.local, 
-				       &tr->accept_data.remote,
-				       &tr->accept_data.addrlen);
-	    if (status==PJ_SUCCESS) {
-		pj_sock_close(tr->accept_data.sock);
-	    } else if (status != PJ_EPENDING) {
-		destroy_transport(mgr, tr);
-		return status;
-	    }
-	} while (status==PJ_SUCCESS);
-
-    } else 
-#endif
-    if (type == PJSIP_TRANSPORT_UDP) {
-	pj_ssize_t bytes;
-
-	/* Discard immediate data. */
-	do {
-	    tr->rdata->addr_len = sizeof(tr->rdata->addr);
-	    bytes = PJSIP_MAX_PKT_LEN;
-	    status = pj_ioqueue_recvfrom( tr->key, &tr->rdata->op_key,
-					  tr->rdata->packet, &bytes, 0,
-					  &tr->rdata->addr, 
-					  &tr->rdata->addr_len);
-	    if (status == PJ_SUCCESS) {
-		;
-	    } else if (status != PJ_EPENDING) {
-		destroy_transport(mgr, tr);
-		return status;
-	    }
-	} while (status == PJ_SUCCESS);
-    }
-
-    pj_atomic_set(tr->ref_cnt, 1);
-
-    /* Listeners normally have no remote address */
-    pj_memset(&tr->remote_addr, 0, sizeof(tr->remote_addr));
-
-    /* Set remote address to 127.0.0.1 for UDP socket bound to 127.0.0.1. 
-     * See further comments on struct pjsip_transport_t definition.
+
+/*
+ * pjsip_tpmgr_receive_packet()
+ *
+ * Called by tranports when they receive a new packet.
+ */
+PJ_DEF(pj_ssize_t) pjsip_tpmgr_receive_packet( pjsip_tpmgr *mgr,
+					       pjsip_rx_data *rdata)
+{
+    pjsip_transport *tr = rdata->tp_info.transport;
+    pj_str_t s;
+
+    char *current_pkt;
+    pj_size_t remaining_len;
+    pj_size_t total_processed = 0;
+
+    /* Check size. */
+    pj_assert(rdata->pkt_info.len > 0);
+    if (rdata->pkt_info.len <= 0)
+	return -1;
+    
+    current_pkt = rdata->pkt_info.packet;
+    remaining_len = rdata->pkt_info.len;
+    
+    /* Must NULL terminate buffer. This is the requirement of the 
+     * parser etc. 
      */
-    if (type == PJSIP_TRANSPORT_UDP && 
-	local_addr->sin_addr.s_addr == pj_inet_addr(&loopback_addr).s_addr)
-    {
-	pj_str_t localaddr = pj_str("127.0.0.1");
-	pj_sockaddr_in_set_str_addr( &tr->remote_addr, &localaddr);
-    }
-    hash_key = pj_pool_alloc(tr->pool, sizeof(transport_key));
-    init_key_from_transport(hash_key, tr);
-
-    pj_mutex_lock(mgr->mutex);
-    pj_hash_set(tr->pool, mgr->transport_table, 
-		hash_key, sizeof(transport_key), tr);
-    pj_mutex_unlock(mgr->mutex);
-
-    PJ_LOG(4,(tr->obj_name, "Listening at %s %s:%d", 
-			 get_type_name(tr->type), 
-			 pj_inet_ntoa(tr->local_addr.sin_addr),
-			 pj_sockaddr_in_get_port(&tr->local_addr)));
-    PJ_LOG(4,(tr->obj_name, "Listener public address is at %s %s:%d", 
-			 get_type_name(tr->type), 
-			 pj_inet_ntoa(tr->addr_name.sin_addr),
-			 pj_sockaddr_in_get_port(&tr->addr_name)));
-    return PJ_SUCCESS;
-}
-
-/*
- * Create listener.
- */
-PJ_DEF(pj_status_t) pjsip_create_listener( pjsip_transport_mgr *mgr,
-					   pjsip_transport_type_e type,
-					   pj_sockaddr_in *local_addr,
-					   const pj_sockaddr_in *addr_name)
-{
-    pj_sock_t sock_hnd;
-    pj_status_t status;
-
-    PJ_LOG(5, (LOG_TRANSPORT_MGR, "pjsip_create_listener(type=%d)", type));
-
-    status = create_socket(type, local_addr, &sock_hnd);
-    if (status != PJ_SUCCESS) {
-	return status;
-    }
-
-    return create_listener(mgr, type, sock_hnd, local_addr, addr_name);
-}
-
-/*
- * Create UDP listener.
- */
-PJ_DEF(pj_status_t) pjsip_create_udp_listener( pjsip_transport_mgr *mgr,
-					       pj_sock_t sock,
-					       const pj_sockaddr_in *addr_name)
-{
-    pj_sockaddr_in local_addr;
-    pj_status_t status;
-    int addrlen = sizeof(local_addr);
-
-    status = pj_sock_getsockname(sock, (pj_sockaddr_t*)&local_addr, &addrlen);
-    if (status != PJ_SUCCESS)
-	return status;
-
-    return create_listener(mgr, PJSIP_TRANSPORT_UDP, sock, 
-			   &local_addr, addr_name);
-}
-
-/*
- * Find transport to be used to send message to remote destination. If no
- * suitable transport is found, a new one will be created.
- */
-PJ_DEF(void) pjsip_transport_get( pjsip_transport_mgr *mgr,
-			          pj_pool_t *pool,
-				  pjsip_transport_type_e type,
-				  const pj_sockaddr_in *remote,
-				  void *token,
-				  pjsip_transport_completion_callback *cb)
-{
-    transport_key search_key, *hash_key;
-    pjsip_transport_t *tr;
-    pj_sockaddr_in local;
-    pj_sock_t sock_hnd;
-    pj_status_t status;
-    struct transport_callback *cb_rec;
-
-    PJ_LOG(5, (LOG_TRANSPORT_MGR, "pjsip_transport_get()"));
-
-    /* Create the callback record.
-     */
-    cb_rec = pj_pool_calloc(pool, 1, sizeof(*cb_rec));
-    cb_rec->token = token;
-    cb_rec->cb = cb;
-
-    /* Create key for hash table look-up.
-     * The key creation is different for TCP and UDP.
-     */
-#if PJ_HAS_TCP
-    if (type==PJSIP_TRANSPORT_TCP) {
-	init_tcp_key(&search_key, type, remote);
-    } else 
-#endif
-    if (type==PJSIP_TRANSPORT_UDP) {
-	init_udp_key(&search_key, type, remote);
-    }
-
-    /* Start lock the manager. */
-    pj_mutex_lock(mgr->mutex);
-
-    /* Lookup the transport in the hash table. */
-    tr = pj_hash_get(mgr->transport_table, &search_key, sizeof(transport_key));
-
-    if (tr) {
-	/* Transport found. If the transport is still busy (i.e. connecting
-	 * is in progress), then just register the callback. Otherwise
-	 * report via the callback if callback is specified. 
+    current_pkt[remaining_len] = '\0';
+
+    /* Process all message fragments. */
+    while (total_processed < remaining_len) {
+
+	pjsip_msg *msg;
+	pj_size_t msg_fragment_size = 0;
+
+	/* Initialize default fragment size. */
+	msg_fragment_size = remaining_len;
+
+	/* Null terminate packet. */
+
+	/* Clear and init msg_info in rdata. 
+	 * Endpoint might inspect the values there when we call the callback
+	 * to report some errors.
 	 */
-	pj_mutex_unlock(mgr->mutex);
-	pj_mutex_lock(tr->tr_mutex);
-
-	if (tr->flag & PJSIP_TRANSPORT_IOQUEUE_BUSY) {
-	    /* Transport is busy. Just register the callback. */
-	    pj_list_insert_before(&tr->cb_list, cb_rec);
-
-	} else {
-	    /* Transport is ready. Call callback now.
-	     */
-	    (*cb_rec->cb)(tr, cb_rec->token, PJ_SUCCESS);
-	}
-	pj_mutex_unlock(tr->tr_mutex);
-
-	return;
-    }
-
-
-    /* Transport not found. Create new one. */
-    pj_memset(&local, 0, sizeof(local));
-    local.sin_family = PJ_AF_INET;
-    status = create_socket(type, &local, &sock_hnd);
-    if (status != PJ_SUCCESS) {
-	pj_mutex_unlock(mgr->mutex);
-	(*cb_rec->cb)(NULL, cb_rec->token, status);
-	return;
-    }
-    status = create_transport(mgr, type, sock_hnd, &local, NULL, &tr);
-    if (status != PJ_SUCCESS) {
-	pj_mutex_unlock(mgr->mutex);
-	(*cb_rec->cb)(NULL, cb_rec->token, status);
-	return;
-    }
-
-#if PJ_HAS_TCP
-    if (type == PJSIP_TRANSPORT_TCP) {
-	pj_memcpy(&tr->remote_addr, remote, sizeof(pj_sockaddr_in));
-	status = pj_ioqueue_connect(tr->key, &tr->remote_addr, 
-				    sizeof(pj_sockaddr_in));
-	pj_assert(status != 0);
-	if (status != PJ_EPENDING) {
-	    PJ_TODO(HANDLE_IMMEDIATE_CONNECT);
-	    destroy_transport(mgr, tr);
-	    pj_mutex_unlock(mgr->mutex);
-	    (*cb_rec->cb)(NULL, cb_rec->token, status);
-	    return;
-	}
-    } else 
-#endif
-    if (type == PJSIP_TRANSPORT_UDP) {
-	pj_ssize_t size;
-
-	do {
-	    tr->rdata->addr_len = sizeof(tr->rdata->addr);
-	    size = PJSIP_MAX_PKT_LEN;
-	    status = pj_ioqueue_recvfrom( tr->key, &tr->rdata->op_key,
-					  tr->rdata->packet, &size, 0,
-					  &tr->rdata->addr, 
-					  &tr->rdata->addr_len);
-	    if (status == PJ_SUCCESS)
-		;
-	    else if (status != PJ_EPENDING) {
-		destroy_transport(mgr, tr);
-		pj_mutex_unlock(mgr->mutex);
-		(*cb_rec->cb)(NULL, cb_rec->token, status);
-		return;
-	    }
-
-	    /* Bug here.
-	     * If data is immediately available, although not likely, it will
-	     * be dropped because we don't expect to have data right after
-	     * the socket is created, do we ?!
-	     */
-	    PJ_TODO(FIXED_BUG_ON_IMMEDIATE_TRANSPORT_DATA);
-
-	} while (status == PJ_SUCCESS);
-
-	//Bug: cb will never be called!
-	//     Must force status to PJ_SUCCESS;
-	//status = PJ_IOQUEUE_PENDING;
-
-	status = PJ_SUCCESS;
-
-    } else {
-	pj_mutex_unlock(mgr->mutex);
-	(*cb_rec->cb)(NULL, cb_rec->token, PJSIP_EUNSUPTRANSPORT);
-	return;
-    }
-
-    pj_assert(status==PJ_EPENDING || status==PJ_SUCCESS);
-    pj_mutex_lock(tr->tr_mutex);
-    hash_key = pj_pool_alloc(tr->pool, sizeof(transport_key));
-    pj_memcpy(hash_key, &search_key, sizeof(transport_key));
-    pj_hash_set(tr->pool, mgr->transport_table, 
-		hash_key, sizeof(transport_key), tr);
-    if (status == PJ_SUCCESS) {
-	pj_mutex_unlock(tr->tr_mutex);
-	pj_mutex_unlock(mgr->mutex);
-	(*cb_rec->cb)(tr, cb_rec->token, PJ_SUCCESS);
-    } else {
-	pj_list_insert_before(&tr->cb_list, cb_rec);
-	pj_mutex_unlock(tr->tr_mutex);
-	pj_mutex_unlock(mgr->mutex);
-    }
-
-}
-
-#if PJ_HAS_TCP
-/*
- * Handle completion of asynchronous accept() operation.
- * This function is called by handle_events() function.
- */
-static void handle_new_connection( pjsip_transport_mgr *mgr,
-				   pjsip_transport_t *listener,
-				   pj_status_t status )
-{
-    pjsip_transport_t *tr;
-    transport_key *hash_key;
-    pj_ssize_t size;
-
-    pj_assert (listener->type == PJSIP_TRANSPORT_TCP);
-
-    if (status != PJ_SUCCESS) {
-	PJSIP_ENDPT_LOG_ERROR((mgr->endpt, listener->obj_name, status,
-			       "Error in accept() completion"));
-	goto on_return;
-    }
-
-    PJ_LOG(4,(listener->obj_name, "incoming tcp connection from %s:%d",
-	      pj_inet_ntoa(listener->accept_data.remote.sin_addr),
-	      pj_sockaddr_in_get_port(&listener->accept_data.remote)));
-
-    status = create_transport(mgr, listener->type, 
-			      listener->accept_data.sock,
-			      &listener->accept_data.local,
-			      NULL, &tr);
-    if (status != PJ_SUCCESS) {
-	PJSIP_ENDPT_LOG_ERROR((mgr->endpt, listener->obj_name, status,
-			       "Error in creating new incoming TCP"));
-	goto on_return;
-    }
-
-    /*
-    tr->rdata->addr_len = sizeof(tr->rdata->addr);
-    status = pj_ioqueue_recvfrom( mgr->ioqueue, tr->key, 
-				  tr->rdata->packet, PJSIP_MAX_PKT_LEN,
-				  &tr->rdata->addr, 
-				  &tr->rdata->addr_len);
-    */
-    tr->rdata->addr = listener->accept_data.remote;
-    tr->rdata->addr_len = listener->accept_data.addrlen;
-
-    size = PJSIP_MAX_PKT_LEN;
-    status = pj_ioqueue_recv(tr->key, &tr->rdata->op_key, 
-			     tr->rdata->packet, &size, 0);
-    if (status != PJ_EPENDING) {
-	PJSIP_ENDPT_LOG_ERROR((mgr->endpt, listener->obj_name, status,
-			       "Error in receiving data"));
-	PJ_TODO(IMMEDIATE_DATA);
-	destroy_transport(mgr, tr);
-	goto on_return;
-    }
-
-    pj_memcpy(&tr->remote_addr, &listener->accept_data.remote, 
-	      listener->accept_data.addrlen);
-    hash_key = pj_pool_alloc(tr->pool, sizeof(transport_key));
-    init_key_from_transport(hash_key, tr);
-
-    pj_mutex_lock(mgr->mutex);
-    pj_hash_set(tr->pool, mgr->transport_table, hash_key, 
-		sizeof(transport_key), tr);
-    pj_mutex_unlock(mgr->mutex);
-
-on_return:
-    /* Re-initiate asynchronous accept() */
-    listener->accept_data.addrlen = sizeof(listener->accept_data.local);
-    status = pj_ioqueue_accept(listener->key, &listener->accept_op,
-			       &listener->accept_data.sock, 
-			       &listener->accept_data.local, 
-			       &listener->accept_data.remote,
-			       &listener->accept_data.addrlen);
-    if (status != PJ_EPENDING) {
-	PJSIP_ENDPT_LOG_ERROR((mgr->endpt, listener->obj_name, status,
-			       "Error in receiving data"));
-	PJ_TODO(IMMEDIATE_ACCEPT);
-	return;
-    }
-}
-
-/*
- * Handle completion of asynchronous connect() function.
- * This function is called by the handle_events() function.
- */
-static void handle_connect_completion( pjsip_transport_mgr *mgr,
-				       pjsip_transport_t *tr,
-				       pj_status_t status )
-{
-    struct transport_callback new_list;
-    struct transport_callback *cb_rec;
-    pj_ssize_t recv_size;
-
-    PJ_UNUSED_ARG(mgr);
-
-    /* On connect completion, we must call all registered callbacks in
-     * the transport.
-     */
-
-    /* Initialize new list. */
-    pj_list_init(&new_list);
-
-    /* Hold transport's mutex. We don't want other thread to register a 
-     * callback while we're dealing with it. 
-    */
-    pj_mutex_lock(tr->tr_mutex);
-
-    /* Copy callback list to new list so that we can call the callbacks
-     * without holding the mutex.
-     */
-    pj_list_merge_last(&new_list, &tr->cb_list);
-
-    /* Clear transport's busy flag. */
-    tr->flag &= ~PJSIP_TRANSPORT_IOQUEUE_BUSY;
-
-    /* If success, update local address. 
-     * Local address is only available after connect() has returned.
-     */
-    if (status == PJ_SUCCESS) {
-	int addrlen = sizeof(tr->local_addr);
-	
-	status = pj_sock_getsockname(tr->sock, 
-				     (pj_sockaddr_t*)&tr->local_addr, 
-				     &addrlen);
-	if (status == PJ_SUCCESS) {
-	    pj_memcpy(&tr->addr_name, &tr->local_addr, sizeof(tr->addr_name));
-	}
-    }
-
-    /* Unlock mutex. */
-    pj_mutex_unlock(tr->tr_mutex);
-
-    /* Call all registered callbacks. */
-    cb_rec = new_list.next;
-    while (cb_rec != &new_list) {
-	struct transport_callback *next;
-	next = cb_rec->next;
-	(*cb_rec->cb)(tr, cb_rec->token, status);
-	cb_rec = next;
-    }
-
-    /* Success? */
-    if (status != PJ_SUCCESS) {
-	destroy_transport(mgr, tr);
-	PJ_TODO(WTF);
-	return;
-    }
-
-    /* Initiate read operation to socket. */
-    recv_size = PJSIP_MAX_PKT_LEN;
-    status = pj_ioqueue_recv( tr->key, &tr->rdata->op_key, tr->rdata->packet, 
-			      &recv_size, 0);
-    if (status != PJ_EPENDING) {
-	destroy_transport(mgr, tr);
-	PJ_TODO(IMMEDIATE_DATA);
-	return;
-    }
-}
-#endif /* PJ_HAS_TCP */
-
-/*
- * Handle incoming data.
- * This function is called when the transport manager receives 'notification'
- * from the I/O Queue that the receive operation has completed.
- * This function will then attempt to parse the message, and hands over the
- * message to the endpoint.
- */
-static void handle_received_data( pjsip_transport_mgr *mgr,
-				  pjsip_transport_t *tr,
-				  pj_ssize_t size )
-{
-    pjsip_msg *msg;
-    pjsip_rx_data *rdata = tr->rdata;
-    pj_pool_t *rdata_pool;
-    pjsip_hdr *hdr;
-    pj_str_t s;
-    char *src_addr;
-    int src_port;
-    pj_size_t msg_fragment_size = 0;
-
-    /* Check size. */
-    if (size < 1) {
-	if (tr->type != PJSIP_TRANSPORT_UDP) {
-	    /* zero bytes indicates transport has been closed for TCP.
-	     * But alas, we can't destroy it now since transactions may still
-	     * have reference to it. In that case, just do nothing, the 
-	     * transaction will receive error when it tries to send anything.
-	     * But alas!! UAC transactions wont send anything!!.
-	     * So this is a bug!
-	     */
-	    if (pj_atomic_get(tr->ref_cnt)==0) {
-		PJ_LOG(4,(tr->obj_name, "connection closed"));
-		destroy_transport(mgr, tr);
-	    } else {
-		PJ_TODO(HANDLE_TCP_TRANSPORT_CLOSED);
-		//PJ_TODO(SIGNAL_TRANSACTIONS_ON_TRANSPORT_CLOSED);
-	    }
-	    return;
-	} else {
-	    /* On Windows machines, UDP recv() will return zero upon receiving
-	     * ICMP port unreachable message.
-	     */
-	    PJ_LOG(4,(tr->obj_name, "Ignored zero length UDP packet (port unreachable?)"));
-	    goto on_return;
-	}
-    }
-    
-    /* Save received time. */
-    pj_gettimeofday(&rdata->timestamp);
-    
-    /* Update length. */
-    rdata->len += size;
-
-    /* Null terminate packet, this is the requirement of the parser. */
-    rdata->packet[rdata->len] = '\0';
-
-    /* Get source address and port for logging purpose. */
-    src_addr = pj_inet_ntoa(rdata->addr.sin_addr);
-    src_port = pj_sockaddr_in_get_port(&rdata->addr);
-
-    /* Print the whole data to the log. */
-    PJ_LOG(4,(tr->obj_name, "%d bytes recvfrom %s:%d:\n"
-		    "----------- begin msg ------------\n"
-		    "%s"
-		    "------------ end msg -------------", 
-	       rdata->len, src_addr, src_port, rdata->packet));
-
-
-    /* Process all message fragments. */
-    while (rdata->len > 0) {
-
-	msg_fragment_size = rdata->len;
-#if PJ_HAS_TCP
+	pj_memset(&rdata->msg_info, 0, sizeof(rdata->msg_info));
+	pj_list_init(&rdata->msg_info.parse_err);
+	rdata->msg_info.msg_buf = current_pkt;
+	rdata->msg_info.len = remaining_len;
+
 	/* For TCP transport, check if the whole message has been received. */
-	if (tr->type != PJSIP_TRANSPORT_UDP) {
+	if ((tr->flag & PJSIP_TRANSPORT_DATAGRAM) == 0) {
 	    pj_status_t msg_status;
-	    msg_status = pjsip_find_msg(rdata->packet, rdata->len, PJ_FALSE, 
+	    msg_status = pjsip_find_msg(current_pkt, remaining_len, PJ_FALSE, 
                                         &msg_fragment_size);
 	    if (msg_status != PJ_SUCCESS) {
-		if (rdata->len == PJSIP_MAX_PKT_LEN) {
-                    PJSIP_ENDPT_LOG_ERROR((mgr->endpt, tr->obj_name, 
-                                           PJSIP_EOVERFLOW,
-                                           "Buffer discarded for %s:%d",
-			                   src_addr, src_port));
-		    goto on_return;
+		if (remaining_len == PJSIP_MAX_PKT_LEN) {
+		    mgr->msg_cb(mgr->endpt, PJSIP_EOVERFLOW, rdata);
+		    /* Exhaust all data. */
+		    return rdata->pkt_info.len;
 		} else {
-		    goto tcp_read_packet;
+		    /* Not enough data in packet. */
+		    return total_processed;
 		}
 	    }
 	}
-#endif
-
-	/* Clear parser error report */
-	pj_list_init(&rdata->parse_err);
+
+	/* Update msg_info. */
+	rdata->msg_info.len = msg_fragment_size;
 
 	/* Parse the message. */
-	PJ_LOG(5,(tr->obj_name, "Parsing %d bytes from %s:%d", msg_fragment_size,
-		src_addr, src_port));
-
-	msg = pjsip_parse_rdata( rdata->packet, msg_fragment_size, rdata);
+	rdata->msg_info.msg = msg = 
+	    pjsip_parse_rdata( current_pkt, msg_fragment_size, rdata);
 	if (msg == NULL) {
-	    PJ_LOG(3,(tr->obj_name, "Bad message (%d bytes from %s:%d)", msg_fragment_size,
-		    src_addr, src_port));
+	    mgr->msg_cb(mgr->endpt, PJSIP_EINVALIDMSG, rdata);
 	    goto finish_process_fragment;
 	}
 
 	/* Perform basic header checking. */
-	if (rdata->call_id.ptr == NULL || rdata->from == NULL || 
-	    rdata->to == NULL || rdata->via == NULL || rdata->cseq == NULL) 
+	if (rdata->msg_info.call_id.ptr == NULL || 
+	    rdata->msg_info.from == NULL || 
+	    rdata->msg_info.to == NULL || 
+	    rdata->msg_info.via == NULL || 
+	    rdata->msg_info.cseq == NULL) 
 	{
-	    PJ_LOG(3,(tr->obj_name, "Bad message from %s:%d: missing some header", 
-		    src_addr, src_port));
+	    mgr->msg_cb(mgr->endpt, PJSIP_EMISSINGHDR, rdata);
 	    goto finish_process_fragment;
 	}
 
-	/* If message is received from address that's different from the sent-by,
+	/* If message is received from address that's different from sent-by,
   	 * MUST add received parameter to the via.
-	 * In our case, we add Via receive param for EVERY received message, 
-	 * because it saves us from resolving the host HERE in case sent-by is in
-	 * FQDN format. And it doesn't hurt either.
 	 */
-	s = pj_str(src_addr);
-	pj_strdup(rdata->pool, &rdata->via->recvd_param, &s);
+	s = pj_str(pj_inet_ntoa(rdata->pkt_info.addr.sin_addr));
+	if (pj_strcmp(&s, &rdata->msg_info.via->sent_by.host) != 0) {
+	    pj_strdup(rdata->tp_info.pool, 
+		      &rdata->msg_info.via->recvd_param, &s);
+	}
 
 	/* RFC 3581:
 	 * If message contains "rport" param, put the received port there.
 	 */
-	if (rdata->via->rport_param == 0) {
-	    rdata->via->rport_param = pj_sockaddr_in_get_port(&rdata->addr);
+	if (rdata->msg_info.via->rport_param == 0) {
+	    rdata->msg_info.via->rport_param = 
+		pj_ntohs(rdata->pkt_info.addr.sin_port);
 	}
 
@@ -1470,11 +708,10 @@
 	*/
 	if (msg->type == PJSIP_RESPONSE_MSG) {
-	    hdr = (pjsip_hdr*)rdata->via->next;
-	    if (hdr != &rdata->msg->hdr) {
+	    pjsip_hdr *hdr;
+	    hdr = (pjsip_hdr*)rdata->msg_info.via->next;
+	    if (hdr != &msg->hdr) {
 		hdr = pjsip_msg_find_hdr(msg, PJSIP_H_VIA, hdr);
 		if (hdr) {
-		    PJ_LOG(3,(tr->obj_name, "Bad message from %s:%d: "
-					    "multiple Via in response message",
-					    src_addr, src_port));
+		    mgr->msg_cb(mgr->endpt, PJSIP_EMULTIPLEVIA, rdata);
 		    goto finish_process_fragment;
 		}
